%  path.m
%  This program can be used after dyn.m to compute perfect foresight paths

%  To run this program ncs has to be defined and MU1 MU2 the partitions
%  of R, Q, P and PS cannot be erased from dyn


T2 = 30;   %  Number of periods during which the shocks vary
	  %  The Tth value has to be the new steady state value

TT = 40;  %  Number of periods for which paths are to be computed

e=zeros(ne,TT);
e(1,1)    = epshat(j);
e(1,2:TT) = epshat2(j+1:j+TT-1);
% e(1,2:3)
% pause
%
f0 = 0;
% Fill in shocks
c1 = PS21*Rke+PS22*Rle;
c2 = PS21*Qke+PS22*Qle;
%
diagonal=diag(MU2);
MU2=zeros(size(MU2));
MU2(1,1)=diagonal(1,1);MU2(2,2)=diagonal(2,1);MU2(3,3)=diagonal(3,1);
for t = 1:T2
    MU2b=zeros(size(MU2));
    MU2b(1,1)=MU2(1,1)^(-t+1);
    MU2b(2,2)=MU2(2,2)^(-t+1);
    MU2b(3,3)=MU2(3,3)^(-t+1);
	f0 = f0 + (MU2b)*(c1*e(:,t+1) + c2*e(:,t));
end
MU2c=zeros(size(MU2));
MU2c(1,1)=MU2(1,1)^(-T2-1);
MU2c(2,2)=MU2(2,2)^(-T2-1);
MU2c(3,3)=MU2(3,3)^(-T2-1);
%
diagonal1=(diag(MU1));
MU1=zeros(size(MU1));
MU1(1,1)=diagonal1(1,1);MU1(2,2)=diagonal1(2,1);MU1(3,3)=diagonal1(3,1);
%
f0 = -inv(MU2)*f0 - inv(eye(size(MU2))-inv(MU2))*(MU2c)*(c1+c2)*e(:,T2);
lamtil0 = f0;
lam0 = inv(PS22)*(lamtil0 - PS21*k0);

klam(1:ns+ncs,1) = [k0 
                   lam0];
f(:,1) = f0;

M1 = [P11*MU1*PS11   P11*MU1*PS12
     P21*MU1*PS11   P21*MU1*PS12];

M2 = [P11*(PS11*Rke+PS12*Rle)
     P21*(PS11*Rke+PS12*Rle)];


M3 = [P11*(PS11*Qke+PS12*Qle)
     P21*(PS11*Qke+PS12*Qle)];

M4 = [P12
      P22];


for t = 1:TT-1

	f(:,t+1) = MU2*f(:,t) + (c1*e(:,t+1) + c2*e(:,t));
	klam(:,t+1) = M1*klam(:,t) + M2*e(:,t+1) + M3*e(:,t) + M4*f(:,t+1);

end

% clear M1 M2 M3 M4 c1 c2 

controls = inv(Mcc)*(Mcs*klam + Mce*e);

ke = [klam(1:ns,:)
        e];

%flows = FVc*controls + FVke*ke + FVl*klam(ns+1:ns+ncs,:);

%  Include variables in a single IR matrix so that the usual programs 
%  to plot impulse response functions can be used

nir = 10;
IR = [(1:TT)' klam(1:ns,:)' e' klam(ns+1:ns+ncs,:)' controls' ];

